package hatenahaiku4j.sample;

import hatenahaiku4j.HatenaHaikuAPI;
import hatenahaiku4j.HatenaHaikuAPILight;
import hatenahaiku4j.HatenaHaikuException;
import hatenahaiku4j.Keyword;
import hatenahaiku4j.LoginUser;
import hatenahaiku4j.Status;
import hatenahaiku4j.util.HatenaUtil;
import hatenahaiku4j.util.StringUtil;

import java.util.List;

/**
 * HatenaHaiku4J TvNXł
 * 
 * @since v0.0.1
 * @author fumokmm
 */
public class Main {
	
	/**
	 * CłB
	 * 
	 * @param args
	 */
	public static void main(String[] args) {
		// OC[U
		LoginUser loginUser = new LoginUser("userid", "password");
		// F؂API
		HatenaHaikuAPI api = new HatenaHaikuAPI(loginUser);
		// F؂ȂAPI
		HatenaHaikuAPILight apiLight = new HatenaHaikuAPILight();

		try {
//			demo_v0_0_1(api, apiLight);	// v0.0.1f
			demo_v0_2_1(api, apiLight);	// v0.2.1f
			
		} catch(HatenaHaikuException e) {
			e.printStackTrace();
		}
	}
	
	/**
	 * v0.0.1_ł̃fłB
	 * 
	 * @param api F؂API
	 * @param apiLight F؂ȂAPI
	 */
	private static void demo_v0_0_1(HatenaHaikuAPI api, HatenaHaikuAPILight apiLight)
		throws HatenaHaikuException {

		printSeparate("pubN^CCo͂");
		List<Status> publicTimeline = apiLight.getPublicTimeline();
		for (Status status : publicTimeline) {
			printStatus(status);
		}

		printSeparate("L[[h^CCo͂(ЂƂ育)");
		List<Status> hitorigotoTimeline = apiLight.getKeywordTimeline("ЂƂ育");
		// apiLight𗘗pĂ܂Aapi𗘗p邱Ƃ\łB
		for (Status status : hitorigotoTimeline) {
			printStatus(status);
		}
		
		printSeparate("OC[Uidy[WɓeB");
		Status result = api.entry("ɂ\n͂ĂȃnCNSiI\nfeXgłB");
		printStatus(result);
		
		printSeparate("łɍo^̃GgɃX^[3قǂĂ݂");
		String targetStatusId = result.getStatusId();
		for (int i = 0; i < 3; i++) {
			Status addStarResult = api.addStar(targetStatusId);
			printStatus(addStarResult);
		}

		printSeparate("ɁAReplyĂ݂");
		Status replyResult = api.reply(targetStatusId, "vCł܂B");
		printStatus(replyResult);
	}
	
	/**
	 * v0.2.1_ł̃fłB<br/>
	 * v0.2.0_Ɏ擾ʂFXł悤ɂȂ܂B<br/>
	 * fev0.0.1_ƓƂɁA[UIDy[W̃^CC擾Ă܂B
	 * 
	 * @param api F؂API
	 * @param apiLight F؂ȂAPI
	 */
	private static void demo_v0_2_1(HatenaHaikuAPI api, HatenaHaikuAPILight apiLight)
		throws HatenaHaikuException {

		printSeparate("pubN^CCo͂");
		List<Status> publicTimeline = apiLight.getPublicTimeline();
		for (Status status : publicTimeline) {
			printStatus(status);
		}

		printSeparate("L[[h^CCo͂(ЂƂ育)");
		Keyword hitorigoto = apiLight.getKeyword("ЂƂ育");
		// Keyword, Status, User  #api ƂtB[ht߁A
		// eCX^XapiĂяo悤ɂȂ܂B
		for (Status status : hitorigoto.api.getTimeline()) {
			printStatus(status);
		}
		
		printSeparate("OC[Uidy[WɓeB");
		Keyword idPage = api.getMyKeyword();
		Status result = idPage.api.entry("ɂ\n͂ĂȃnCNSiI\nfeXgłB");
		printStatus(result);
		
		printSeparate("łɍo^̃GgɃX^[3قǂĂ݂");
		for (int i = 0; i < 3; i++) {
			printStatus(result.api.addStar());
		}

		printSeparate("ɁAReplyĂ݂");
		printStatus(result.api.reply("vCł܂B"));
		
		printSeparate("OC[Uidy[W^CCo͂");
		for (Status idStatus : api.getMe().api.getIdTimeline()) {
			printStatus(idStatus);
		}
	}

	/**
	 * Xe[^XWo͂ɏo͂܂B
	 * 
	 * @param status Xe[^X
	 */
	private static void printStatus(Status status) {
		StringBuilder sb = new StringBuilder();
		sb.append("y").append(status.getKeyword()).append("z");
		sb.append(HatenaUtil.formatDate(status.getCreatedAt()));
		sb.append("k~").append(status.getFavorited()).append("l");
		sb.append(status.getText());
		if (!StringUtil.isEmpty(status.getInReplyToStatusId())) {
			sb.append(" reply to ").append(status.getInReplyToUserId());
		}
		sb.append(" by ").append(status.getUserId());
		sb.append(" from ").append(status.getSource());
		if (!status.getReplies().isEmpty()) {
			StringBuilder replies = new StringBuilder();
			for (Status reply : status.getReplies()) {
				if (replies.length() > 0) {
					replies.append(", ");
				}
				replies.append(reply.getUserId());
			}
			sb.append(" replied from ").append(replies);
		}
		System.out.println(sb.toString());
	}

	/**
	 * ؂Wo͂ɏo͂܂B
	 * 
	 * @param label x
	 */
	private static void printSeparate(String label) {
		System.out.println("----------" + label + "----------");
	}
}
