package hatenahaiku4j.util;

import hatenahaiku4j.Const;
import hatenahaiku4j.HatenaHaikuException;
import hatenahaiku4j.LoginUser;
import hatenahaiku4j.QueryParameter;
import hatenahaiku4j.UpdateParameter;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.List;
import java.util.Map;

/**
 * HTTPNGXgɊւ郆[eBeBNX
 * 
 * @since v0.0.1
 * @author fumokmm
 */
public class HttpUtil {
	/** METHOD */
	private static enum Method { POST, GET }
	/** NGXgvpeBFBASICF */
	protected static final String REQUEST_PROPERTY_AUTHORIZATION = "Authorization";
	/** NGXgvpeB:RlNV */
	protected static final String REQUEST_PROPERTY_CONNECTION = "Connection";
	/** NGXgvpeB:RlNV (l:close) */
	protected static final String REQUEST_PROPERTY_CONNECTION_CLOSE = "close";
	
	/**
	 * Qbg܂B
	 * 
	 * @param url NGXgURL
	 * @param param NGXgp[^
	 * @param needLog Oo͗v
	 * @return X|X{fB̕
	 * @throws MalformedURLException
	 * @throws IOException
	 * @since v0.0.1
	 */
	public static String doGet(String url, QueryParameter param, boolean needLog) throws MalformedURLException, IOException {
		return doGet(null, url, param, needLog);
	}

	/**
	 * Qbg܂B
	 * 
	 * @param loginUser OC[U
	 * @param url NGXgURL
	 * @param param NGXgp[^
	 * @param needLog Oo͗v
	 * @return X|X{fB̕
	 * @throws UnsupportedEncodingException
	 * @throws MalformedURLException
	 * @throws IOException
	 * @since v0.0.1
	 */
	public static String doGet(LoginUser loginUser, String url,
			QueryParameter param, boolean needLog) throws UnsupportedEncodingException,
			MalformedURLException, IOException {

		HttpURLConnection urlconn = null; // RlNV
		try {
			urlconn = (HttpURLConnection) new URL(url).openConnection();
			urlconn.setRequestMethod(Method.GET.name());
			if (loginUser != null) {
				urlconn.setRequestProperty(REQUEST_PROPERTY_AUTHORIZATION, loginUser.toBasicAuthenticationString());
			}
			// GETAoutputStream擾邽outputtrueƂ
			urlconn.setDoInput(true);		// for GET
			urlconn.setDoOutput(true);		// for POST
			urlconn.setUseCaches(false);	// disable cache
			// ŏɂčŌ̗v
			urlconn.setRequestProperty(REQUEST_PROPERTY_CONNECTION, REQUEST_PROPERTY_CONNECTION_CLOSE);
			
			// |Xge̕\
			if (param != null) {
				if (needLog) {
					param.outputPostInfo();
				}
			}

			PrintWriter writer = new PrintWriter(urlconn.getOutputStream());
			if (param != null) {
				writer.write(param.toParameter());
			}
			writer.flush();
			writer.close();

			// X|X
			return getResponse(urlconn, needLog);

		} catch (UnsupportedEncodingException e) {
			if (needLog) {
				System.out.println(urlconn.getRequestMethod() + " failure");
			}
			e.printStackTrace();
			throw e;

		} catch (MalformedURLException e) {
			if (needLog) {
				System.out.println(urlconn.getRequestMethod() + " failure");
			}
			e.printStackTrace();
			throw e;

		} catch (IOException e) {
			if (needLog) {
				System.out.println(urlconn.getRequestMethod() + " failure");
			}
			e.printStackTrace();
			throw e;

		} finally {
			// RlNVؒf
			urlconn.disconnect();
		}
	}

	/**
	 * |Xg܂B
	 * 
	 * @param loginUser OC[U
	 * @param url NGXgURL
	 * @param param NGXgp[^
	 * @param needLog Oo͗v
	 * @return X|X{fB̕
	 * @throws UnsupportedEncodingException
	 * @throws MalformedURLException
	 * @throws IOException
	 * @throws HatenaHaikuException 
	 * @since v0.0.1
	 */
	public static String doPost(LoginUser loginUser, String url,
			UpdateParameter param, boolean needLog) throws UnsupportedEncodingException,
			MalformedURLException, IOException, HatenaHaikuException {

		HttpURLConnection urlconn = null; // RlNV
		try {
			urlconn = (HttpURLConnection) new URL(url).openConnection();
			urlconn.setRequestMethod(Method.POST.name());
			urlconn.setRequestProperty(REQUEST_PROPERTY_AUTHORIZATION, loginUser.toBasicAuthenticationString());
			// L[[hw̏ꍇ́AOC[UIDƂB
			if (param.getKeyword() == null || param.getKeyword().equals("")) {
				param.setKeyword(loginUser.getUserIdNotation());
			}
			// POST̂߁AInput/OutputƂtrue
			urlconn.setDoInput(true);		// for GET
			urlconn.setDoOutput(true);		// for POST
			urlconn.setUseCaches(false);	// disable cache
			// ŏɂčŌ̗v
			urlconn.setRequestProperty(REQUEST_PROPERTY_CONNECTION, REQUEST_PROPERTY_CONNECTION_CLOSE);
			
			// |Xge̕\
			if (needLog) {
				param.outputPostInfo(loginUser);
			}

			PrintWriter writer = new PrintWriter(urlconn.getOutputStream());
			// TODO 摜t@C𓊍e (file p[^w) ꍇ́Amultipart/form-data ŃGR[hĉB
			writer.write(param.toParameter(loginUser));
			writer.flush();
			writer.close();
			
			// X|X
			return getResponse(urlconn, needLog);

		} catch (UnsupportedEncodingException e) {
			if (needLog) {
				System.out.println(urlconn.getRequestMethod() + " failure");
			}
			e.printStackTrace();
			throw e;

		} catch (MalformedURLException e) {
			if (needLog) {
				System.out.println(urlconn.getRequestMethod() + " failure");
			}
			e.printStackTrace();
			throw e;

		} catch (IOException e) {
			if (needLog) {
				System.out.println(urlconn.getRequestMethod() + " failure");
			}
			e.printStackTrace();
			throw e;

		} finally {
			// RlNVؒf
			urlconn.disconnect();
		}
	}
	
	/**
	 * X|Xԋp܂B
	 * 
	 * @param urlconn@HTTPRlNV
	 * @param needLog Oo͗v
	 * @return X|X{fB̕
	 * @throws UnsupportedEncodingException
	 * @throws IOException
	 * @since v0.0.1
	 */
	private static String getResponse(HttpURLConnection urlconn, boolean needLog)
			throws MalformedURLException, IOException {

		try {
			// X|X
			Map<String, List<String>> headers = urlconn.getHeaderFields();
			if (needLog) {
				for (Map.Entry<String, List<String>> entry : headers.entrySet()) {
					System.out.println(entry.getKey() + ": " + entry.getValue());
				}
			}
			// {fB
			StringBuilder responseBody = new StringBuilder();
			BufferedReader responseReader = new BufferedReader(new InputStreamReader(urlconn.getInputStream(), Const.UTF8));
			String line;
			while((line = responseReader.readLine()) != null) {
				responseBody.append(line);
			}

			if (needLog) {
				System.out.println("----------------");
				System.out.println("X|XR[h: " + urlconn.getResponseCode());
				System.out.println("X|XbZ[W: " + urlconn.getResponseMessage());
				System.out.println("----------------");
				System.out.println(urlconn.getRequestMethod() + " successfully");
			}
			return responseBody.toString();

		} catch (UnsupportedEncodingException e) {
			if (needLog) {
				System.out.println(urlconn.getRequestMethod() + " failure");
			}
			e.printStackTrace();
			throw e;

		} catch (IOException e) {
			if (needLog) {
				System.out.println(urlconn.getRequestMethod() + " failure");
			}
			e.printStackTrace();
			throw e;

		} finally {
			// RlNVؒf
			urlconn.disconnect();
		}
	}
}
